Go to the latest version of this document.
search in docstrings

Search bar offers the following options:

- Term presence. The below example searches for documents that must contain “foo”, might contain “bar” and must not contain “baz”: `+foo bar -baz`
- Wildcards. The below example searches for documents with words beginning with “foo”: `foo*`
- Search in specific fields. The following search matches all objects in "twisted.mail" that matches “search”: `+qname:twisted.mail.* +search`

  Possible fields: 'name', 'qname' (fully qualified name), 'docstring', and 'kind'. Last two fields are only applicable if "search in docstrings" is enabled.

- Fuzzy matches. The following search matches all documents that have a word within 1 edit distance of “foo”: `foo~1`

Results provided by Lunr.js

# ``twisted`.`persisted`.`dirdbm`.`DirDBM``

class documentation

`class DirDBM: (source)`

Known subclasses: `twisted.persisted.dirdbm.Shelf`

Constructor: `DirDBM(name)`

View In Hierarchy

A directory with a DBM interface.

This class presents a hash-like interface to a directory of small, flat files. It can only use strings as keys or values.

Method | `__contains__` | No summary
Method | `__delitem__` | `del dirdbm[foo]` Delete a file in this directory.
Method | `__getitem__` | `dirdbm[k]` Get the contents of a file in this directory as a string.
Method | `__init__` | No summary
Method | `__len__` | No summary
Method | `__setitem__` | `dirdbm[k] = v` Create or modify a textfile in this directory
Method | `clear` | Delete all key/value pairs in this dirdbm.
Method | `close` | Close this dbm: no-op, for dbm-style interface compliance.
Method | `copyTo` | Copy the contents of this dirdbm to the dirdbm at `path`.
Method | `get` | No summary
Method | `getModificationTime` | Returns modification time of an entry.
Method | `has_key` | No summary
Method | `items` | No summary
Method | `keys` | No summary
Method | `setdefault` | No summary
Method | `update` | Add all the key/value pairs in `dict` to this dirdbm. Any conflicting keys will be overwritten with the values from `dict`.
Method | `values` | No summary
Instance Variable | `dname` | Undocumented
Method | `_decode` | Decode a filename to get the key.
Method | `_encode` | Encode a key so it can be used as a filename.
Method | `_readFile` | Read in the contents of a file.
Method | `_writeFile` | Write data to a file.
Instance Variable | `_dnamePath` | Undocumented

def __contains__(self, key): (source)

See Also
`DirDBM.has_key`

def __delitem__(self, k): (source)

`del dirdbm[foo]` Delete a file in this directory.

Parameters
k:bytes | key to delete
Raises
`KeyError` | Raised when there is no such key

def __getitem__(self, k): (source)
overridden in `twisted.persisted.dirdbm.Shelf`

`dirdbm[k]` Get the contents of a file in this directory as a string.

Parameters
k:bytes | key to lookup
Returns
The value associated with `k`
Raises
`KeyError` | Raised when there is no such key

def __init__(self, name): (source)

Parameters
name:str | Base path to use for the directory storage.

def __len__(self): (source)

Returns
The number of key/value pairs in this Shelf

def __setitem__(self, k, v): (source)
overridden in `twisted.persisted.dirdbm.Shelf`

`dirdbm[k] = v` Create or modify a textfile in this directory

Parameters
k:bytes | key to set
v:bytes | value to associate with `k`

def clear(self): (source)

Delete all key/value pairs in this dirdbm.

def close(self): (source)

Close this dbm: no-op, for dbm-style interface compliance.

def copyTo(self, path): (source)

Copy the contents of this dirdbm to the dirdbm at `path`.

Parameters
path:`str` | The path of the dirdbm to copy to. If a dirdbm exists at the destination path, it is cleared first.
Returns
`DirDBM` | The dirdbm this dirdbm was copied to.

def get(self, key, default=None): (source)

Parameters
key:bytes | The key to lookup
default | The value to return if the given key does not exist
Returns
The value associated with `key` or `default` if not `DirDBM.has_key(key)`

def getModificationTime(self, key): (source)

Returns modification time of an entry.

Returns
Last modification date (seconds since epoch) of entry `key`
Raises
`KeyError` | Raised when there is no such key

def has_key(self, key): (source)

Parameters
key:bytes | The key to test
Returns
A true value if this dirdbm has the specified key, a false value otherwise.

def items(self): (source)

Returns
a `list` of 2-tuples containing key/value pairs.

def keys(self): (source)

Returns
a `list` of filenames (keys).

def setdefault(self, key, value): (source)

Parameters
key:bytes | The key to lookup
value | The value to associate with key if key is not already associated with a value.

def update(self, dict): (source)

Add all the key/value pairs in `dict` to this dirdbm. Any conflicting keys will be overwritten with the values from `dict`.

Parameters
dict:mapping | A mapping of key/value pairs to add to this dirdbm.

def values(self): (source)

Returns
a `list` of file-contents (values).

dname = (source)

Undocumented

def _decode(self, k): (source)

Decode a filename to get the key.

def _encode(self, k): (source)

Encode a key so it can be used as a filename.

def _readFile(self, path): (source)

Read in the contents of a file.

Override in subclasses to e.g. provide transparently encrypted dirdbm.

def _writeFile(self, path, data): (source)

Write data to a file.

Override in subclasses to e.g. provide transparently encrypted dirdbm.

_dnamePath = (source)

Undocumented